<script setup lang="ts">
import { useStockStore } from '@/stores/stock'
import { useAuthStore } from '@/stores/auth'
import PrintDialog from './PrintDialog.vue'

import { onMounted, ref } from 'vue'

import { useCheckStockStore } from '@/stores/checkstock'

const stockStore = useStockStore()
const authStore = useAuthStore()
const checkStockStore = useCheckStockStore()
const currentDate = ref()
const currentTime = ref()
const now = new Date()
const time = new Date().toLocaleTimeString()
const headers = [
  {
    key: 'id',
    sortable: false,
    title: 'ProuductId'
  },
  { key: 'name', title: 'ProuductName', sortable: false },
  { key: 'minimum', title: 'Minimum', sortable: false },
  { key: 'balance', title: 'Balance', sortable: false },
  { key: 'unit', title: 'Unit', sortable: false },
  { title: 'Amount', key: 'amount', sortable: false }
]

const setupDateAndTime = () => {
  currentDate.value = `${now.getDate()}/${now.getMonth() + 1}/${now.getFullYear()}`
  currentTime.value = `${time}:${now.getMinutes()}`
}

onMounted(() => {
  setupDateAndTime()
})
const blc = ref()
function changeBl() {
  const paInt = (blc.value = parseInt(blc.value, 10))
  let bl = (stockStore.editedSProduct.balance = paInt)
  stockStore.editedSProduct.balance = bl
  clearTxtField()
}
const notifications = ref(false)
const sound = ref(false)
const widgets = ref(false)
function clearTxtField() {
  blc.value = 0
}
function validateNumber(value: any) {
  const isValid = /^\d+$/.test(value)
  return isValid || 'Please enter a number'
}
function save() {
  checkStockStore.addAmountToBalance()

  stockStore.dialogCheckStock = !stockStore.dialogCheckStock
}
function close(){
  stockStore.clearListAmount()
  stockStore.dialogCheckStock = !stockStore.dialogCheckStock
}
onMounted(async () => {
  console.log("Get Stock");
  await stockStore.getStocks()
})
</script>
<template>
  <v-dialog
    v-model="stockStore.dialogCheckStock"
    fullscreen
    :scrim="false"
    transition="dialog-bottom-transition"
  >
    <v-card>
      <v-toolbar dark color="#403c3c">
        <v-btn icon dark @click="close()">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Check Stock</v-toolbar-title>
        <v-spacer></v-spacer>
      </v-toolbar>

      <v-container>
        <v-row>
          <v-sheet width="1300" height="120">
            <div>ผู้ตรวจนับ:{{ authStore.getCurrentUser()?.fullName  }}</div>
            <div>วันที่:{{ currentDate }} เวลา {{ currentTime }}</div>
          </v-sheet>
        </v-row>
        <v-row no-gutters>
          <v-sheet width="1250" height="500" class="overflow-auto">
            <div style="font-size: 20pt; text-align: center">Check Stock</div>
            <v-data-table :headers="headers" :items="stockStore.stockItems">
              <template v-slot:[`item.amount`]="{ item }">
                <v-text-field  
                v-model="stockStore.listAmount[item.id! -1]"
                  density="compact"
                  inputmode="numeric"
                  pattern="[0-9]*"
                  type="number"
                  :rules="[validateNumber]"
                >
                </v-text-field>
              </template>
            </v-data-table>
          </v-sheet>
          <v-row no-gutters>
            <v-col cols="6" style="padding-top: 20px">
              <div>
                <v-btn prepend-icon="mdi-content-save-check-outline" style="margin-left: 1080px; background-color: #47bb59; color: white;" @click="save">Save</v-btn>
              </div></v-col
            >
            <v-col cols="6" style="padding-top: 20px">
              <div>
                <v-btn prepend-icon="mdi-printer-check" color="primary" style="margin-left: 380px" @click="stockStore.openPrint"
                  >Print</v-btn
                >
              </div></v-col
            >
          </v-row>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>
  <print-dialog></print-dialog>
</template>
<style scoped>
.dialog-bottom-transition-enter-active,
.dialog-bottom-transition-leave-active {
  transition: transform 0.2s ease-in-out;
}
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}
.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
